import{S as Za,i as er,s as tr,e as r,k as m,w as ot,t as l,M as ar,c as i,d as t,m as f,a as s,x as lt,h as p,b as d,P as da,G as a,g as o,y as pt,L as rr,q as mt,o as ft,B as dt,v as ir}from"../../chunks/vendor-hf-doc-builder.js";import{I as ut}from"../../chunks/IconCopyLink-hf-doc-builder.js";function nr(ua){let h,we,c,k,te,S,ht,ae,ct,be,w,gt,re,vt,yt,_e,H,kt,Pe,b,ie,wt,bt,ne,_t,xe,R,Pt,Ee,g,_,se,I,xt,oe,Et,Te,M,le,ha,$e,P,Tt,j,$t,At,Ae,x,zt,pe,Lt,qt,ze,D,Nt,Le,E,St,V,It,Mt,qe,v,T,me,F,Ft,fe,Gt,Ne,G,de,ca,Se,$,Ut,C,Ot,Bt,Ie,W,Ht,Me,A,Rt,ue,jt,Dt,Fe,J,Vt,Ge,z,Ct,K,Wt,Jt,Ue,y,L,he,U,Kt,ce,Qt,Oe,O,ge,ga,Be,q,Xt,Q,Yt,Zt,He,X,ea,Re,u,ve,ta,aa,ye,ra,ia,B,na,ke,sa,oa,je,Y,la,De,N,pa,Z,ma,fa,Ve;return S=new ut({}),I=new ut({}),F=new ut({}),U=new ut({}),{c(){h=r("meta"),we=m(),c=r("h1"),k=r("a"),te=r("span"),ot(S.$$.fragment),ht=m(),ae=r("span"),ct=l("Prompting"),be=m(),w=r("p"),gt=l("Training large pretrained language models is very time-consuming and compute-intensive. As they continue to grow in size, there is increasing interest in more efficient training methods such as "),re=r("em"),vt=l("prompting"),yt=l(". Prompting primes a frozen pretrained model for a specific downstream task by including a text prompt that describes the task or even demonstrates an example of the task. With prompting, you can avoid fully training a separate model for each downstream task, and use the same frozen pretrained model instead. This is a lot easier because you can use the same model for several different tasks, and it is significantly more efficient to train and store a smaller set of prompt parameters than to train all the model\u2019s parameters."),_e=m(),H=r("p"),kt=l("There are two categories of prompting methods:"),Pe=m(),b=r("ul"),ie=r("li"),wt=l("hard prompts are manually handcrafted text prompts with discrete input tokens; the downside is that it requires a lot of effort to create a good prompt"),bt=m(),ne=r("li"),_t=l("soft prompts are learnable tensors concatenated with the input embeddings that can be optimized to a dataset; the downside is that they aren\u2019t human readable because you aren\u2019t matching these \u201Cvirtual tokens\u201D to the embeddings of a real word"),xe=m(),R=r("p"),Pt=l("This conceptual guide provides a brief overview of the soft prompt methods included in \u{1F917} PEFT: prompt tuning, prefix tuning, and P-tuning."),Ee=m(),g=r("h2"),_=r("a"),se=r("span"),ot(I.$$.fragment),xt=m(),oe=r("span"),Et=l("Prompt tuning"),Te=m(),M=r("div"),le=r("img"),$e=m(),P=r("small"),Tt=l("Only train and store a significantly smaller set of task-specific prompt parameters "),j=r("a"),$t=l("(image source)"),At=l("."),Ae=m(),x=r("p"),zt=l("Prompt tuning was developed for text classification tasks on T5 models, and all downstream tasks are cast as a text generation task. For example, sequence classification usually assigns a single class label to a sequence of text. By casting it as a text generation task, the tokens that make up the class label are "),pe=r("em"),Lt=l("generated"),qt=l(". Prompts are added to the input as a series of tokens. Typically, the model parameters are fixed which means the prompt tokens are also fixed by the model parameters."),ze=m(),D=r("p"),Nt=l("The key idea behind prompt tuning is that prompt tokens have their own parameters that are updated independently. This means you can keep the pretrained model\u2019s parameters frozen, and only update the gradients of the prompt token embeddings. The results are comparable to the traditional method of training the entire model, and prompt tuning performance scales as model size increases."),Le=m(),E=r("p"),St=l("Take a look at "),V=r("a"),It=l("Prompt tuning for causal language modeling"),Mt=l(" for a step-by-step guide on how to train a model with prompt tuning."),qe=m(),v=r("h2"),T=r("a"),me=r("span"),ot(F.$$.fragment),Ft=m(),fe=r("span"),Gt=l("Prefix tuning"),Ne=m(),G=r("div"),de=r("img"),Se=m(),$=r("small"),Ut=l("Optimize the prefix parameters for each task "),C=r("a"),Ot=l("(image source)"),Bt=l("."),Ie=m(),W=r("p"),Ht=l("Prefix tuning was designed for natural language generation (NLG) tasks on GPT models. It is very similar to prompt tuning; prefix tuning also prepends a sequence of task-specific vectors to the input that can be trained and updated while keeping the rest of the pretrained model\u2019s parameters frozen."),Me=m(),A=r("p"),Rt=l("The main difference is that the prefix parameters are inserted in "),ue=r("strong"),jt=l("all"),Dt=l(" of the model layers, whereas prompt tuning only adds the prompt parameters to the model input embeddings. The prefix parameters are also optimized by a separate feed-forward network (FFN) instead of training directly on the soft prompts because it causes instability and hurts performance. The FFN is discarded after updating the soft prompts."),Fe=m(),J=r("p"),Vt=l("As a result, the authors found that prefix tuning demonstrates comparable performance to fully finetuning a model, despite having 1000x fewer parameters, and it performs even better in low-data settings."),Ge=m(),z=r("p"),Ct=l("Take a look at "),K=r("a"),Wt=l("Prefix tuning for conditional generation"),Jt=l(" for a step-by-step guide on how to train a model with prefix tuning."),Ue=m(),y=r("h2"),L=r("a"),he=r("span"),ot(U.$$.fragment),Kt=m(),ce=r("span"),Qt=l("P-tuning"),Oe=m(),O=r("div"),ge=r("img"),Be=m(),q=r("small"),Xt=l("Prompt tokens can be inserted anywhere in the input sequence, and they are optimized by a prompt encoder "),Q=r("a"),Yt=l("(image source)"),Zt=l("."),He=m(),X=r("p"),ea=l(`P-tuning is designed for natural language understanding (NLU) tasks and all language models.
It is another variation of a soft prompt method; P-tuning also adds a trainable embedding tensor that can be optimized to find better prompts, and it uses a prompt encoder (a bidirectional long-short term memory network or LSTM) to optimize the prompt parameters. Unlike prefix tuning though:`),Re=m(),u=r("ul"),ve=r("li"),ta=l("the prompt tokens can be inserted anywhere in the input sequence, and it isn\u2019t restricted to only the beginning"),aa=m(),ye=r("li"),ra=l("the prompt tokens are only added to the input instead of adding them to every layer of the model"),ia=m(),B=r("li"),na=l("introducing "),ke=r("em"),sa=l("anchor"),oa=l(" tokens can improve performance because they indicate characteristics of a component in the input sequence"),je=m(),Y=r("p"),la=l("The results suggest that P-tuning is more efficient than manually crafting prompts, and it enables GPT-like models to compete with BERT-like models on NLU tasks."),De=m(),N=r("p"),pa=l("Take a look at "),Z=r("a"),ma=l("P-tuning for sequence classification"),fa=l(" for a step-by-step guide on how to train a model with P-tuning."),this.h()},l(e){const n=ar('[data-svelte="svelte-1phssyn"]',document.head);h=i(n,"META",{name:!0,content:!0}),n.forEach(t),we=f(e),c=i(e,"H1",{class:!0});var Ce=s(c);k=i(Ce,"A",{id:!0,class:!0,href:!0});var va=s(k);te=i(va,"SPAN",{});var ya=s(te);lt(S.$$.fragment,ya),ya.forEach(t),va.forEach(t),ht=f(Ce),ae=i(Ce,"SPAN",{});var ka=s(ae);ct=p(ka,"Prompting"),ka.forEach(t),Ce.forEach(t),be=f(e),w=i(e,"P",{});var We=s(w);gt=p(We,"Training large pretrained language models is very time-consuming and compute-intensive. As they continue to grow in size, there is increasing interest in more efficient training methods such as "),re=i(We,"EM",{});var wa=s(re);vt=p(wa,"prompting"),wa.forEach(t),yt=p(We,". Prompting primes a frozen pretrained model for a specific downstream task by including a text prompt that describes the task or even demonstrates an example of the task. With prompting, you can avoid fully training a separate model for each downstream task, and use the same frozen pretrained model instead. This is a lot easier because you can use the same model for several different tasks, and it is significantly more efficient to train and store a smaller set of prompt parameters than to train all the model\u2019s parameters."),We.forEach(t),_e=f(e),H=i(e,"P",{});var ba=s(H);kt=p(ba,"There are two categories of prompting methods:"),ba.forEach(t),Pe=f(e),b=i(e,"UL",{});var Je=s(b);ie=i(Je,"LI",{});var _a=s(ie);wt=p(_a,"hard prompts are manually handcrafted text prompts with discrete input tokens; the downside is that it requires a lot of effort to create a good prompt"),_a.forEach(t),bt=f(Je),ne=i(Je,"LI",{});var Pa=s(ne);_t=p(Pa,"soft prompts are learnable tensors concatenated with the input embeddings that can be optimized to a dataset; the downside is that they aren\u2019t human readable because you aren\u2019t matching these \u201Cvirtual tokens\u201D to the embeddings of a real word"),Pa.forEach(t),Je.forEach(t),xe=f(e),R=i(e,"P",{});var xa=s(R);Pt=p(xa,"This conceptual guide provides a brief overview of the soft prompt methods included in \u{1F917} PEFT: prompt tuning, prefix tuning, and P-tuning."),xa.forEach(t),Ee=f(e),g=i(e,"H2",{class:!0});var Ke=s(g);_=i(Ke,"A",{id:!0,class:!0,href:!0});var Ea=s(_);se=i(Ea,"SPAN",{});var Ta=s(se);lt(I.$$.fragment,Ta),Ta.forEach(t),Ea.forEach(t),xt=f(Ke),oe=i(Ke,"SPAN",{});var $a=s(oe);Et=p($a,"Prompt tuning"),$a.forEach(t),Ke.forEach(t),Te=f(e),M=i(e,"DIV",{class:!0});var Aa=s(M);le=i(Aa,"IMG",{src:!0}),Aa.forEach(t),$e=f(e),P=i(e,"SMALL",{});var Qe=s(P);Tt=p(Qe,"Only train and store a significantly smaller set of task-specific prompt parameters "),j=i(Qe,"A",{href:!0});var za=s(j);$t=p(za,"(image source)"),za.forEach(t),At=p(Qe,"."),Qe.forEach(t),Ae=f(e),x=i(e,"P",{});var Xe=s(x);zt=p(Xe,"Prompt tuning was developed for text classification tasks on T5 models, and all downstream tasks are cast as a text generation task. For example, sequence classification usually assigns a single class label to a sequence of text. By casting it as a text generation task, the tokens that make up the class label are "),pe=i(Xe,"EM",{});var La=s(pe);Lt=p(La,"generated"),La.forEach(t),qt=p(Xe,". Prompts are added to the input as a series of tokens. Typically, the model parameters are fixed which means the prompt tokens are also fixed by the model parameters."),Xe.forEach(t),ze=f(e),D=i(e,"P",{});var qa=s(D);Nt=p(qa,"The key idea behind prompt tuning is that prompt tokens have their own parameters that are updated independently. This means you can keep the pretrained model\u2019s parameters frozen, and only update the gradients of the prompt token embeddings. The results are comparable to the traditional method of training the entire model, and prompt tuning performance scales as model size increases."),qa.forEach(t),Le=f(e),E=i(e,"P",{});var Ye=s(E);St=p(Ye,"Take a look at "),V=i(Ye,"A",{href:!0});var Na=s(V);It=p(Na,"Prompt tuning for causal language modeling"),Na.forEach(t),Mt=p(Ye," for a step-by-step guide on how to train a model with prompt tuning."),Ye.forEach(t),qe=f(e),v=i(e,"H2",{class:!0});var Ze=s(v);T=i(Ze,"A",{id:!0,class:!0,href:!0});var Sa=s(T);me=i(Sa,"SPAN",{});var Ia=s(me);lt(F.$$.fragment,Ia),Ia.forEach(t),Sa.forEach(t),Ft=f(Ze),fe=i(Ze,"SPAN",{});var Ma=s(fe);Gt=p(Ma,"Prefix tuning"),Ma.forEach(t),Ze.forEach(t),Ne=f(e),G=i(e,"DIV",{class:!0});var Fa=s(G);de=i(Fa,"IMG",{src:!0}),Fa.forEach(t),Se=f(e),$=i(e,"SMALL",{});var et=s($);Ut=p(et,"Optimize the prefix parameters for each task "),C=i(et,"A",{href:!0});var Ga=s(C);Ot=p(Ga,"(image source)"),Ga.forEach(t),Bt=p(et,"."),et.forEach(t),Ie=f(e),W=i(e,"P",{});var Ua=s(W);Ht=p(Ua,"Prefix tuning was designed for natural language generation (NLG) tasks on GPT models. It is very similar to prompt tuning; prefix tuning also prepends a sequence of task-specific vectors to the input that can be trained and updated while keeping the rest of the pretrained model\u2019s parameters frozen."),Ua.forEach(t),Me=f(e),A=i(e,"P",{});var tt=s(A);Rt=p(tt,"The main difference is that the prefix parameters are inserted in "),ue=i(tt,"STRONG",{});var Oa=s(ue);jt=p(Oa,"all"),Oa.forEach(t),Dt=p(tt," of the model layers, whereas prompt tuning only adds the prompt parameters to the model input embeddings. The prefix parameters are also optimized by a separate feed-forward network (FFN) instead of training directly on the soft prompts because it causes instability and hurts performance. The FFN is discarded after updating the soft prompts."),tt.forEach(t),Fe=f(e),J=i(e,"P",{});var Ba=s(J);Vt=p(Ba,"As a result, the authors found that prefix tuning demonstrates comparable performance to fully finetuning a model, despite having 1000x fewer parameters, and it performs even better in low-data settings."),Ba.forEach(t),Ge=f(e),z=i(e,"P",{});var at=s(z);Ct=p(at,"Take a look at "),K=i(at,"A",{href:!0});var Ha=s(K);Wt=p(Ha,"Prefix tuning for conditional generation"),Ha.forEach(t),Jt=p(at," for a step-by-step guide on how to train a model with prefix tuning."),at.forEach(t),Ue=f(e),y=i(e,"H2",{class:!0});var rt=s(y);L=i(rt,"A",{id:!0,class:!0,href:!0});var Ra=s(L);he=i(Ra,"SPAN",{});var ja=s(he);lt(U.$$.fragment,ja),ja.forEach(t),Ra.forEach(t),Kt=f(rt),ce=i(rt,"SPAN",{});var Da=s(ce);Qt=p(Da,"P-tuning"),Da.forEach(t),rt.forEach(t),Oe=f(e),O=i(e,"DIV",{class:!0});var Va=s(O);ge=i(Va,"IMG",{src:!0}),Va.forEach(t),Be=f(e),q=i(e,"SMALL",{});var it=s(q);Xt=p(it,"Prompt tokens can be inserted anywhere in the input sequence, and they are optimized by a prompt encoder "),Q=i(it,"A",{href:!0});var Ca=s(Q);Yt=p(Ca,"(image source)"),Ca.forEach(t),Zt=p(it,"."),it.forEach(t),He=f(e),X=i(e,"P",{});var Wa=s(X);ea=p(Wa,`P-tuning is designed for natural language understanding (NLU) tasks and all language models.
It is another variation of a soft prompt method; P-tuning also adds a trainable embedding tensor that can be optimized to find better prompts, and it uses a prompt encoder (a bidirectional long-short term memory network or LSTM) to optimize the prompt parameters. Unlike prefix tuning though:`),Wa.forEach(t),Re=f(e),u=i(e,"UL",{});var ee=s(u);ve=i(ee,"LI",{});var Ja=s(ve);ta=p(Ja,"the prompt tokens can be inserted anywhere in the input sequence, and it isn\u2019t restricted to only the beginning"),Ja.forEach(t),aa=f(ee),ye=i(ee,"LI",{});var Ka=s(ye);ra=p(Ka,"the prompt tokens are only added to the input instead of adding them to every layer of the model"),Ka.forEach(t),ia=f(ee),B=i(ee,"LI",{});var nt=s(B);na=p(nt,"introducing "),ke=i(nt,"EM",{});var Qa=s(ke);sa=p(Qa,"anchor"),Qa.forEach(t),oa=p(nt," tokens can improve performance because they indicate characteristics of a component in the input sequence"),nt.forEach(t),ee.forEach(t),je=f(e),Y=i(e,"P",{});var Xa=s(Y);la=p(Xa,"The results suggest that P-tuning is more efficient than manually crafting prompts, and it enables GPT-like models to compete with BERT-like models on NLU tasks."),Xa.forEach(t),De=f(e),N=i(e,"P",{});var st=s(N);pa=p(st,"Take a look at "),Z=i(st,"A",{href:!0});var Ya=s(Z);ma=p(Ya,"P-tuning for sequence classification"),Ya.forEach(t),fa=p(st," for a step-by-step guide on how to train a model with P-tuning."),st.forEach(t),this.h()},h(){d(h,"name","hf:doc:metadata"),d(h,"content",JSON.stringify(sr)),d(k,"id","prompting"),d(k,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(k,"href","#prompting"),d(c,"class","relative group"),d(_,"id","prompt-tuning"),d(_,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(_,"href","#prompt-tuning"),d(g,"class","relative group"),da(le.src,ha="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/peft/prompt-tuning.png")||d(le,"src",ha),d(M,"class","flex justify-center"),d(j,"href","https://arxiv.org/abs/2104.08691"),d(V,"href","../task_guides/clm-prompt-tuning"),d(T,"id","prefix-tuning"),d(T,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(T,"href","#prefix-tuning"),d(v,"class","relative group"),da(de.src,ca="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/peft/prefix-tuning.png")||d(de,"src",ca),d(G,"class","flex justify-center"),d(C,"href","https://arxiv.org/abs/2101.00190"),d(K,"href","../task_guides/seq2seq-prefix-tuning"),d(L,"id","ptuning"),d(L,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(L,"href","#ptuning"),d(y,"class","relative group"),da(ge.src,ga="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/peft/p-tuning.png")||d(ge,"src",ga),d(O,"class","flex justify-center"),d(Q,"href","https://arxiv.org/abs/2103.10385"),d(Z,"href","../task_guides/ptuning-seq-classification")},m(e,n){a(document.head,h),o(e,we,n),o(e,c,n),a(c,k),a(k,te),pt(S,te,null),a(c,ht),a(c,ae),a(ae,ct),o(e,be,n),o(e,w,n),a(w,gt),a(w,re),a(re,vt),a(w,yt),o(e,_e,n),o(e,H,n),a(H,kt),o(e,Pe,n),o(e,b,n),a(b,ie),a(ie,wt),a(b,bt),a(b,ne),a(ne,_t),o(e,xe,n),o(e,R,n),a(R,Pt),o(e,Ee,n),o(e,g,n),a(g,_),a(_,se),pt(I,se,null),a(g,xt),a(g,oe),a(oe,Et),o(e,Te,n),o(e,M,n),a(M,le),o(e,$e,n),o(e,P,n),a(P,Tt),a(P,j),a(j,$t),a(P,At),o(e,Ae,n),o(e,x,n),a(x,zt),a(x,pe),a(pe,Lt),a(x,qt),o(e,ze,n),o(e,D,n),a(D,Nt),o(e,Le,n),o(e,E,n),a(E,St),a(E,V),a(V,It),a(E,Mt),o(e,qe,n),o(e,v,n),a(v,T),a(T,me),pt(F,me,null),a(v,Ft),a(v,fe),a(fe,Gt),o(e,Ne,n),o(e,G,n),a(G,de),o(e,Se,n),o(e,$,n),a($,Ut),a($,C),a(C,Ot),a($,Bt),o(e,Ie,n),o(e,W,n),a(W,Ht),o(e,Me,n),o(e,A,n),a(A,Rt),a(A,ue),a(ue,jt),a(A,Dt),o(e,Fe,n),o(e,J,n),a(J,Vt),o(e,Ge,n),o(e,z,n),a(z,Ct),a(z,K),a(K,Wt),a(z,Jt),o(e,Ue,n),o(e,y,n),a(y,L),a(L,he),pt(U,he,null),a(y,Kt),a(y,ce),a(ce,Qt),o(e,Oe,n),o(e,O,n),a(O,ge),o(e,Be,n),o(e,q,n),a(q,Xt),a(q,Q),a(Q,Yt),a(q,Zt),o(e,He,n),o(e,X,n),a(X,ea),o(e,Re,n),o(e,u,n),a(u,ve),a(ve,ta),a(u,aa),a(u,ye),a(ye,ra),a(u,ia),a(u,B),a(B,na),a(B,ke),a(ke,sa),a(B,oa),o(e,je,n),o(e,Y,n),a(Y,la),o(e,De,n),o(e,N,n),a(N,pa),a(N,Z),a(Z,ma),a(N,fa),Ve=!0},p:rr,i(e){Ve||(mt(S.$$.fragment,e),mt(I.$$.fragment,e),mt(F.$$.fragment,e),mt(U.$$.fragment,e),Ve=!0)},o(e){ft(S.$$.fragment,e),ft(I.$$.fragment,e),ft(F.$$.fragment,e),ft(U.$$.fragment,e),Ve=!1},d(e){t(h),e&&t(we),e&&t(c),dt(S),e&&t(be),e&&t(w),e&&t(_e),e&&t(H),e&&t(Pe),e&&t(b),e&&t(xe),e&&t(R),e&&t(Ee),e&&t(g),dt(I),e&&t(Te),e&&t(M),e&&t($e),e&&t(P),e&&t(Ae),e&&t(x),e&&t(ze),e&&t(D),e&&t(Le),e&&t(E),e&&t(qe),e&&t(v),dt(F),e&&t(Ne),e&&t(G),e&&t(Se),e&&t($),e&&t(Ie),e&&t(W),e&&t(Me),e&&t(A),e&&t(Fe),e&&t(J),e&&t(Ge),e&&t(z),e&&t(Ue),e&&t(y),dt(U),e&&t(Oe),e&&t(O),e&&t(Be),e&&t(q),e&&t(He),e&&t(X),e&&t(Re),e&&t(u),e&&t(je),e&&t(Y),e&&t(De),e&&t(N)}}}const sr={local:"prompting",sections:[{local:"prompt-tuning",title:"Prompt tuning"},{local:"prefix-tuning",title:"Prefix tuning"},{local:"ptuning",title:"P-tuning"}],title:"Prompting"};function or(ua){return ir(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class mr extends Za{constructor(h){super();er(this,h,or,nr,tr,{})}}export{mr as default,sr as metadata};
